Unit MDChars;
{unit contain public method SendStr2MD, which send string to MiniDisc
this method using only standard 12 bit codes}

interface

uses
  Infrared,Crt;

procedure SendStr2MD(S:String);
  {send string (title) to MiniDisc, require selected "Name" mode with
  default setting (UpperCase characters).
  Not terminated "Name" mode, only send string S to MD.
  After exit, UpperCase mode is not selected always!!!}


const
  MaxSizeCharCodeTable=255;  {max size of CharCodeTable}

type
  tContrMode=(Numeric,LowerCase,UpperCase,AnyCase,Any);  {mod - title mode on Remote Controller}
            {AnyCase = LowerCase or UpperCase; Any = Character or Numeric}
  tCharCodeTableElement=record
    Character:Char;
    ContrMode:tContrMode;
    IRCode:tIRCodeString;
  end;
  tCharCodeTable=array[1..MaxSizeCharCodeTable] of tCharCodeTableElement;

  tCharCodes=object
   private
    Table:tCharCodeTable;
    Size:Integer;
   public
    constructor Ini;
    destructor Done;
    function GetContrMode(Ch:Char):tContrMode;
      {return title mode for character Ch}
    function GetIRCode(Ch:Char):tIRCodeString;
      {return IR Code for character Ch}
    function KnownCode(S:tIRCodeString):Boolean;
  end;


var
  CharCodes:tCharCodes;

implementation


constructor tCharCodes.Ini;
  var
    I:Integer;
  begin
    I:=0;
    Inc(I); with Table[I] do begin Character:='1'; ContrMode:=Numeric; IRCode:=ir_SonyMD_1; end;
    Inc(I); with Table[I] do begin Character:='2'; ContrMode:=Numeric; IRCode:=ir_SonyMD_2; end;
    Inc(I); with Table[I] do begin Character:='3'; ContrMode:=Numeric; IRCode:=ir_SonyMD_3; end;
    Inc(I); with Table[I] do begin Character:='4'; ContrMode:=Numeric; IRCode:=ir_SonyMD_4; end;
    Inc(I); with Table[I] do begin Character:='5'; ContrMode:=Numeric; IRCode:=ir_SonyMD_5; end;
    Inc(I); with Table[I] do begin Character:='6'; ContrMode:=Numeric; IRCode:=ir_SonyMD_6; end;
    Inc(I); with Table[I] do begin Character:='7'; ContrMode:=Numeric; IRCode:=ir_SonyMD_7; end;
    Inc(I); with Table[I] do begin Character:='8'; ContrMode:=Numeric; IRCode:=ir_SonyMD_8; end;
    Inc(I); with Table[I] do begin Character:='9'; ContrMode:=Numeric; IRCode:=ir_SonyMD_9; end;
    Inc(I); with Table[I] do begin Character:='0'; ContrMode:=Numeric; IRCode:=ir_SonyMD_10; end;
    Inc(I); with Table[I] do begin Character:='A'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_ContPlay; end;
    Inc(I); with Table[I] do begin Character:='B'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_Shuffle; end;
    Inc(I); with Table[I] do begin Character:='C'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_Program; end;
    Inc(I); with Table[I] do begin Character:='D'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_DPre; end;
    Inc(I); with Table[I] do begin Character:='E'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_DRec; end;
    Inc(I); with Table[I] do begin Character:='F'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_1; end;
    Inc(I); with Table[I] do begin Character:='G'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_2; end;
    Inc(I); with Table[I] do begin Character:='H'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_3; end;
    Inc(I); with Table[I] do begin Character:='I'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_4; end;
    Inc(I); with Table[I] do begin Character:='J'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_5; end;
    Inc(I); with Table[I] do begin Character:='K'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_6; end;
    Inc(I); with Table[I] do begin Character:='L'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_7; end;
    Inc(I); with Table[I] do begin Character:='M'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_8; end;
    Inc(I); with Table[I] do begin Character:='N'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_9; end;
    Inc(I); with Table[I] do begin Character:='O'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_10; end;
    Inc(I); with Table[I] do begin Character:='P'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_11; end;
    Inc(I); with Table[I] do begin Character:='Q'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_12; end;
    Inc(I); with Table[I] do begin Character:='R'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_13; end;
    Inc(I); with Table[I] do begin Character:='S'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_14; end;
    Inc(I); with Table[I] do begin Character:='T'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_15; end;
    Inc(I); with Table[I] do begin Character:='U'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_16; end;
    Inc(I); with Table[I] do begin Character:='V'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_17; end;
    Inc(I); with Table[I] do begin Character:='W'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_18; end;
    Inc(I); with Table[I] do begin Character:='X'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_19; end;
    Inc(I); with Table[I] do begin Character:='Y'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_20; end;
    Inc(I); with Table[I] do begin Character:='Z'; ContrMode:=UpperCase; IRCode:=ir_SonyMD_21; end;
    Inc(I); with Table[I] do begin Character:='a'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_ContPlay; end;
    Inc(I); with Table[I] do begin Character:='b'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_Shuffle; end;
    Inc(I); with Table[I] do begin Character:='c'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_Program; end;
    Inc(I); with Table[I] do begin Character:='d'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_DPre; end;
    Inc(I); with Table[I] do begin Character:='e'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_DRec; end;
    Inc(I); with Table[I] do begin Character:='f'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_1; end;
    Inc(I); with Table[I] do begin Character:='g'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_2; end;
    Inc(I); with Table[I] do begin Character:='h'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_3; end;
    Inc(I); with Table[I] do begin Character:='i'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_4; end;
    Inc(I); with Table[I] do begin Character:='j'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_5; end;
    Inc(I); with Table[I] do begin Character:='k'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_6; end;
    Inc(I); with Table[I] do begin Character:='l'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_7; end;
    Inc(I); with Table[I] do begin Character:='m'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_8; end;
    Inc(I); with Table[I] do begin Character:='n'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_9; end;
    Inc(I); with Table[I] do begin Character:='o'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_10; end;
    Inc(I); with Table[I] do begin Character:='p'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_11; end;
    Inc(I); with Table[I] do begin Character:='q'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_12; end;
    Inc(I); with Table[I] do begin Character:='r'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_13; end;
    Inc(I); with Table[I] do begin Character:='s'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_14; end;
    Inc(I); with Table[I] do begin Character:='t'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_15; end;
    Inc(I); with Table[I] do begin Character:='u'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_16; end;
    Inc(I); with Table[I] do begin Character:='v'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_17; end;
    Inc(I); with Table[I] do begin Character:='w'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_18; end;
    Inc(I); with Table[I] do begin Character:='x'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_19; end;
    Inc(I); with Table[I] do begin Character:='y'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_20; end;
    Inc(I); with Table[I] do begin Character:='z'; ContrMode:=LowerCase; IRCode:=ir_SonyMD_21; end;
    Inc(I); with Table[I] do begin Character:='/'; ContrMode:=AnyCase; IRCode:=ir_SonyMD_More25; end;
    Inc(I); with Table[I] do begin Character:='?'; ContrMode:=AnyCase; IRCode:=ir_SonyMD_Repeat; end;
    Inc(I); with Table[I] do begin Character:='!'; ContrMode:=AnyCase; IRCode:=ir_SonyMD_ABRepeat; end;
    Inc(I); with Table[I] do begin Character:='('; ContrMode:=AnyCase; IRCode:=ir_SonyMD_ASpace; end;
    Inc(I); with Table[I] do begin Character:=')'; ContrMode:=AnyCase; IRCode:=ir_SonyMD_MScan; end;
    Inc(I); with Table[I] do begin Character:='-'; ContrMode:=AnyCase; IRCode:=ir_SonyMD_22; end;
    Inc(I); with Table[I] do begin Character:='.'; ContrMode:=AnyCase; IRCode:=ir_SonyMD_24; end;
    Inc(I); with Table[I] do begin Character:='''';ContrMode:=AnyCase; IRCode:=ir_SonyMD_25; end;
    Inc(I); with Table[I] do begin Character:=' '; ContrMode:=AnyCase; IRCode:=ir_SonyMD_23; end;
    Size:=I;
  end;

destructor tCharCodes.Done;
  begin
  end;

function tCharCodes.GetContrMode(Ch:Char):tContrMode;
  var
    I:Integer;
  begin
    for I:=1 to Size do
      if Table[I].Character=Ch then
        begin
          GetContrMode:=Table[I].ContrMode;
          Exit;
        end;
    GetContrMode:=Any;
  end;

function tCharCodes.GetIRCode(Ch:Char):tIRCodeString;
  var
    I:Integer;
  begin
    for I:=1 to Size do
      if Table[I].Character=Ch then
        begin
          GetIRCode:=Table[I].IRCode;
          Exit;
        end;
    GetIRCode:='';
  end;

function tCharCodes.KnownCode(S:tIRCodeString):Boolean;
  var
    I:Integer;
  begin
    for I:=1 to Size do
      if Table[I].IrCode=S then
        begin
          KnownCode:=True;
          Exit;
        end;
    KnownCode:=False;
  end;


procedure SendStr2MD(S:String);
  var
    Actmode:tContrMode;
    LastCharMode:tContrMode;
    MyMode:tContrMode;
    MyIRCode:tIRCodeString;
    I:Integer;
  begin
    ActMode:=UpperCase;
    LastCharMode:=UpperCase;
    for I:=1 to Length(S) do
      begin
        Write(S[I]);
        while KeyPressed do
          if ReadKey=#27 then
            Halt;
        MyMode:=CharCodes.GetContrMode(S[I]);
        MyIRCode:=CharCodes.GetIRCode(S[I]);
        if MyIRCode='' then
          begin
            MyMode:=CharCodes.GetContrMode('?');
            MyIRCode:=CharCodes.GetIRCode('?');
          end;
        if (MyMode=Numeric) and (ActMode<>Numeric) then
          begin
            SendCode(ir_SonyMD_Num);
            Delay(ChangeTitleModeDelay);
            ActMode:=Numeric;
          end
        else if (MyMode=UpperCase) and (ActMode<>UpperCase) then
          begin
            SendCode(ir_SonyMD_Char);
            Delay(ChangeTitleModeDelay);
            if (ActMode=Numeric) and (LastCharMode=LowerCase) then
              begin
                SendCode(ir_SonyMD_Char);
                Delay(ChangeTitleModeDelay);
              end;
            ActMode:=UpperCase;
          end
        else if (MyMode=LowerCase) and (ActMode<>LowerCase) then
          begin
            SendCode(ir_SonyMD_Char);
            Delay(ChangeTitleModeDelay);
            if (ActMode=Numeric) and (LastCharMode=UpperCase) then
              begin
                SendCode(ir_SonyMD_Char);
                Delay(ChangeTitleModeDelay);
              end;
            ActMode:=LowerCase;
          end
        else if (MyMode=AnyCase) and (ActMode=Numeric) then
          begin
            SendCode(ir_SonyMD_Char);
            Delay(ChangeTitleModeDelay);
            ActMode:=LastCharMode;
          end;
        SendCode(MyIRCode);
        if ActMode<>Numeric then
          LastCharMode:=ActMode;
      end;
  end;

begin
  CharCodes.Ini;
end.